<?php

namespace EventPortal\Tests\Support\Traits;

use EventPortal\Domain\Admin\Models\Admin;
use Illuminate\Support\Facades\Auth;

trait InteractsWithAdminAuthentication
{
    public function actingAsSuperAdmin(?Admin $admin = null, $driver = null)
    {
        if (Auth::check()) {
            return $this;
        }

        if ($admin === null) {
            $admin = factory(Admin::class)->state('super-admin')->create();
        }

        if ($admin !== null && $admin->hasRole('super-admin') === false) {
            $admin->assignRole('super-admin');
        }

        return $this->be($admin->user, $driver);
    }

    public function actingAsAdmin(?Admin $admin = null, $driver = null)
    {
        if ($admin === null) {
            $admin = factory(Admin::class)->state('admin')->create();
        }


        return $this->be($admin->user, $driver);
    }
}
